﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class sounds : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;


    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        // we put the soundfile in the "sf" folder of the main "Assets"
        String score = "rtinput(\"" + Application.dataPath + "/sf/tty.wav\") ";

        RTcmix.SendScore(score, objno);

        // fade-out and fade-in the file to make it continuous
        score = "dur = 15 " +
            "amp = 1 " +
            "ampenv = maketable(\"line\", 1000, 0,0, 3,1, 12,1, 15,0) " +
            "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
            "MAXBANG(10) ";

        RTcmix.SendScore(score, objno);

        did_start = true;
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);

        if (RTcmix.checkbangRTcmix(objno) == 1) {
            String score = "MIX(0, 0, dur, amp*ampenv, 0, 1) " +
                "MAXBANG(10) ";
            RTcmix.SendScore(score, objno);
        }
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
